/**
 * Deep nested search
 * @param searchKey string key we are looking for
 * @param inputObject
 */
function find(searchKey, inputObject) {
    for (var key in inputObject) {
        if (key === searchKey) {
            // If key matches return object and stop search
            return inputObject[key];
        }
        else {
            // Go deeper
            if (typeof inputObject[key] === 'object') {
                var result = find(searchKey, inputObject[key]);
                if (result !== null)
                    return result;
            }
        }
    }
    // If nothing was fount return null
    return null;
}

export { find };
